/**
 * Created by guosen on 2019-12-5.
 */
import et from  '__ROOTPATH__/H5_common/asset/common_tool/event.js';
import $ from  '__ROOTPATH__/H5_common/asset/common_tool/zepto.js';
import Com from '__ROOTPATH__/H5_common/asset/common_tool/app_common_bridge.js';
import md5Fun from  '__ROOTPATH__/H5_common/asset/common_tool/md5.js';
import tool_fun from '__ROOTPATH__/H5_common/asset/common_tool/common_fun.js';
import UI from '__ROOTPATH__/H5_common/asset/common_tool/UI.js';
import Picker from  '__ROOTPATH__/H5_common/asset/common_tool/picker.min.js';
import Dialog from '__ROOTPATH__/H5_common/asset/common_tool/components/dialog/';//替换新弹窗组件原组件有兼容性

import Vue from 'vue';
require('__ROOTPATH__/H5_common/asset/common_tool/common.css');
require('__ROOTPATH__/H5_common/asset/common_tool/picker.css');

require('../css/common.scss');
require('../css/apply_content.scss');
require('../css/market_trading.scss');
require('__ROOTPATH__/H5_common/asset/common_tool/UI.css');

const marketTradingTpl = require('../tpl/market_trading.html');

const dataObj = {
	type: tool_fun.getParam('type'),   //buy市价买入 sell 市价卖出
	showHolder: '',
	holderList: [], //符号要求的股东账号列表
	holderId: '', //股东账号
	holderMarket: '',
	inputCode: '',
	applyType: '',
	marketBuyArr: ['一', '二', '三', '四', '五'],
	hqInfo: {}, //获取行情
	stockInfo: {}, //股票详情
	buyUnit: 1, //购买单位
	precision: 3,
	market: '',
	price: '',
	maxNuyNum: '',
	buyNum: '',
	countMoney: '',
	showMarket: false,
	mapMarketType: {
		0: '其它',
		1: '基础层',
		2: '创新层',
		3: '精选层'
	}
};
const configData = {
	flag: 1001,// 买入1001  1002卖出
	buyType: [
		{
			text: '对方最优价格买入',
			value: '0a'
		},
		{
			text: '本方最优价格买入',
			value: '0b'
		},
		{
			text: '最优五档即时成交剩余撤销买入',
			value: '0d'
		},
		{
			text: '最优五档即时成交剩余转限价买入',
			value: '0q'
		},
	],
	sellType: [
		{
			text: '对方最优价格卖出',
			value: '0f'
		},
		{
			text: '本方最优价格卖出',
			value: '0g'
		},
		{
			text: '最优五档即时成交剩余撤销卖出',
			value: '0i'
		},
		{
			text: '最优五档即时成交剩余转限价卖出',
			value: '0r'
		},
	],
	isLoading: false
}
et.eventBind();
const exports = {
	init: function () {
		if(dataObj.type == 'sell') {
			configData.buyType = configData.sellType;
			configData.flag = 1002;
		}
		new Vue({
			el: '#domDiv',
			data: dataObj,
			components: {
				[Dialog.name]: Dialog,
			},
			methods: {
				mapTypeToName: function (type) {
					return exports.getApplyType(type);

				},
				inputCodeEvent: function () {
					if(dataObj.inputCode.length > 6){
						dataObj.inputCode = dataObj.inputCode.slice(0, 6);
						exports.initParam();
					}
					if(dataObj.inputCode.length == 6){
						exports.initParam();
						exports.queryStockInfo();
					}
				},
				inputPrice: function () {
					dataObj.maxNuyNum = '';
					if(!dataObj.price) return;
					dataObj.price = dataObj.price.replace(/[^\d.]/g, '');
					if(dataObj.price == '.') {
						dataObj.price = '';
					}
					if(dataObj.price.indexOf('..') != -1 || (dataObj.price.substr(0, dataObj.price.length -1).indexOf('.') != -1 && dataObj.price.substr(dataObj.price.length -1, 1) == '.')) {
						dataObj.price = dataObj.price.substr(0, dataObj.price.length -1)
					}
					configData.inputTimeout && clearTimeout(configData.inputTimeout)
					configData.inputTimeout = setTimeout(function () {
						exports.queryBuyCount();
					}, 500);
					dataObj.countMoney = (dataObj.buyNum * dataObj.price).toFixed(2)
				},
				inputBuyNum: function () {
					if(dataObj.buyNum) {
						dataObj.buyNum = parseInt(dataObj.buyNum);
					}

					if(!dataObj.buyNum || !dataObj.price) return;
					dataObj.countMoney = (dataObj.buyNum * dataObj.price).toFixed(2)
				},
			},
			template: '<div >' + marketTradingTpl + '</div>'
		});
		Com.removeLocalValue('gpdm');
		Com.removeLocalValue('scdm');
		Com.removeLocalValue('secuid');
		if(dataObj.type == 'buy') {
			Com.setWebviewTitle('', {'title': '市价买入(挂牌）'});
		} else {
			Com.setWebviewTitle('', {'title': '市价卖出(挂牌）'});
		}

		exports.getStockHolder('', function () {});
		//exports.queryStockInfo();
		exports.bindEvent()
		Com.gobackRefreshPage(true, function () {
			if(!Com.getLocalValue('gpdm')){
				return;
			}
			exports.initParam();
			if(Com.getLocalValue('gpdm')){
				dataObj.inputCode = Com.getLocalValue('gpdm');
			}



			if(Com.getLocalValue('secuid')) {
				dataObj.holderId = Com.getLocalValue('secuid');
			}
			if(Com.getLocalValue('scdm')) {
				dataObj.market = Com.getLocalValue('scdm');
				dataObj.holderMarket = Com.getLocalValue('scdm');
			}

			Com.removeLocalValue('gpdm');
			Com.removeLocalValue('scdm');
			Com.removeLocalValue('secuid');

			if(!dataObj.inputCode || dataObj.inputCode == 'null') return;
			exports.queryStockInfo(dataObj.market, dataObj.holderId);

		});
	},
	initParam: function () {
		dataObj.hqInfo = {};
		dataObj.stockInfo = {};
		dataObj.price = '';
		dataObj.market = '';
		dataObj.maxNuyNum = '';
		dataObj.buyNum = '';

	},
	getApplyType: function (type) {
		for(let i =0; i < configData.buyType.length; i++) {
			if(configData.buyType[i].value == type) {
				return configData.buyType[i].text;
			}
		}
		return '';
	},
	getSelectIndex: function () {
		for(let i =0; i < configData.buyType.length; i++) {
			if(configData.buyType[i].value == dataObj.applyType) {
				return i;
			}
		}

		return 0;
	},
	bindEvent: function () {
		//搜索可以申购股票
		et.on('search.stock', function () {
			let url =  Com.getOrigin() + '/asset/gzjy/pages/gfcx.html?flag=' + configData.flag;
			Com.newWebViewOpenPage('',{"pageUrl": url, "weburl": url});

		})
		//购买确认按钮
		et.on('buy.btn', function () {
			if(!dataObj.holderId || dataObj.holderId == 'null') {
				Com.showNativeAlert('', '请输入股东代码', ['确定']);
				return;
			}
			if(!dataObj.inputCode || dataObj.inputCode == 'null') {
				Com.showNativeAlert('', '请输入股票代码', ['确定']);
				return;
			}
			if(!dataObj.applyType) {
				Com.showNativeAlert('', (dataObj.type == 'sell' ? '请选择申报类型' : '请选择申报类型'), ['确定']);
				return;
			}
			if(!dataObj.price) {
				Com.showNativeAlert('', '请输入保护限价', ['确定']);
				return;
			}
			if(!dataObj.buyNum) {
				Com.showNativeAlert('', (dataObj.type == 'sell' ? '请输入卖出数量' : '请输入买入数量'), ['确定']);
				return;
			}
			let showTxt = [];
			showTxt.push('股东代码：' + dataObj.holderId);
			showTxt.push('证券代码：' + dataObj.inputCode);
			showTxt.push('证券名称：' + (dataObj.stockInfo ? dataObj.stockInfo.stkname : '--'));
			showTxt.push('申报类型：' + exports.getApplyType(dataObj.applyType));
			showTxt.push('保护限价：' + dataObj.price);
			showTxt.push('委托数量：' + dataObj.buyNum);
			showTxt.push('<br>如股东代码有误请选择正确股东代码');
			window.scrollTo(0, 0);
			Dialog.confirm({
				title: '',
				content: '<div style="text-align: left;padding-left: .5rem;">' + showTxt.join('<br/>') + '</div>',
				confirmText: '确定',
				cancelText: '取消',
				onConfirm: () => {
					UI.showLoading();
					exports.doApply();
				},
				onCancel: () => {

				}
			})

			/*setTimeout(function () {
				UI.showConfirm({
					title: '',
					content: '<div style="text-align: left;padding-left: .5rem;">' + showTxt.join('<br/>') + '</div>',
					sureText: '确定',
					cancelText: '取消',
					sureFn: function () {
						UI.showLoading();
						exports.doApply();
						return true
					},
					cancelFn: function () {
						return true
					},
					onload: function () {
						return true
					}

				})
			})
*/
		});
		//选中输入份额
		et.on('count.add', function (e, t) {
			let count = t.attr('data-count');
			if(!dataObj.maxNuyNum) return;
			dataObj.buyNum = Math.floor(dataObj.maxNuyNum * Number(count));
			if(dataObj.price) {
				dataObj.countMoney = (dataObj.buyNum * dataObj.price).toFixed(2)
			}

		})
		//是否显示市场
		et.on('show.marekt', function () {
			dataObj.showMarket = !dataObj.showMarket;
		})
		//请选择申报类型
		et.on('choose.apply.type', function () {
			var picker = new Picker({
				data: [configData.buyType],
				selectedIndex: [exports.getSelectIndex()],
				title: (dataObj.type == 'sell' ? '选择申报类型' : '选择申报类型')
			});
			picker.show();
			$('.cancel-hook').html("<div class='l-angle'></div>")
			picker.on('picker.select', function (selectVal, selectIndex) {
				//console.log(dataObj.holderList[selectIndex[0]].market)
				dataObj.applyType = selectVal[0];

				//exports.getHolder();
			});
			window.scrollTo(0, 0);
		})
		et.on('choose.stock.holder', function () {
			if(dataObj.holderList.length == 0) {
				Com.showNativeAlert('', '未找到股转股东账号', ['确定'], '');
				return;
			}
			let _data = exports.formatPickerData();
			var picker = new Picker({
				data: [_data.data],
				selectedIndex: [_data.selectIndex],
				title: '切换股东账号'
			});
			picker.show();
			$('.cancel-hook').html("<div class='l-angle'></div>")
			picker.on('picker.select', function (selectVal, selectIndex) {
				//console.log(dataObj.holderList[selectIndex[0]].market)
				dataObj.holderId = selectVal[0];
				dataObj.holderMarket = dataObj.holderList[selectIndex[0]].market;
				if(configData.secuid) {
					configData.secuid = dataObj.holderId;
				}

				if(dataObj.price && dataObj.inputCode) {
					exports.queryBuyCount();
				}
				//exports.getHolder();
			});
		})
	},
	doApply: function () {
		let url = Com.getOrigin() + '/gstrade/sharetransfer/tradeConfirm/1.0';
		let param = {
			secuid: dataObj.holderId,
			market: dataObj.market,
			price: dataObj.price,
			stkcode: dataObj.inputCode,
			qty: dataObj.buyNum,
			bsflag: dataObj.applyType
		}
		exports.getData(url, param, function (d) {
			UI.closeLoading();
			if(d.result[0].code=='0'){
				Com.removeLocalValue('gpdm');
				Com.removeLocalValue('scdm');
				Com.showNativeAlert('', '委托提交成功!\n合同号为:' + d.tradeConfirm_0[0].orderid, ["确定","查看委托"], function(respone){
					if (respone.clickedIndex == '0') {
						window.location.reload();
					}else if(respone.clickedIndex == '1'){
						//Com.newWebViewOpenPage('',{"pageUrl":Com.getOrigin()+'/asset/gzjy/pages/gzwtcx.html',"weburl":'gzwtcx.html'});
						exports.goWtPage();
					}
				});

			}else{
				$('#btn-buy').removeClass('disabled');
				if(d.result[0].msg!=null&&d.result[0].msg!=undefined){
					Com.showNativeAlert('','委托提交失败！原因:'+d.result[0].msg,["确定"],'');
				}else{
					Com.showNativeAlert('','委托提交失败',["确定"],'');
				}
			}

		})
	},
	goWtPage: function () {
		Com.nativeGoback();
		onCallNative('WebContainer', 'transitionFundQuery', {'queryType': 2}, '');
	},
	//获取股东账号
	getStockHolder: function (stkMarket, callback) {
		const random = '_' + (Math.random() + '').split('.')[1];
		const funName = 'setTradeLoginData' + random;
		configData.holderList = [];
		window.$js[funName] = function (tradeLoginData) {
			const shareHold = tradeLoginData.shareholderList;
			if(!shareHold) return;
			for(let i = 0; i < shareHold.length; i++) {
				if(shareHold[i].shareholderMarketId == '6' || shareHold[i].shareholderMarketId == '7'){
					configData.holderList.push({
						market: shareHold[i].shareholderMarketId,
						id: shareHold[i].shareholderId,
						isMaster: shareHold[i].shareholderSecuseq //0是主股东，1 不是
					});

				}
			}
			if(configData.holderList.length > 0){
				//dataObj.showHolder = configData.holderList[0].market + configData.holderList[0].id;
				dataObj.holderMarket = configData.holderList[0].market;
				dataObj.holderId = configData.holderList[0].id;
				dataObj.holderList = configData.holderList;
			}
			callback && callback();
		};
		//从native获取登录参数，判断是否存在尚未开通上海股东账户不能签约金天利
		onCallNative('DataService', 'getTradeLoginData', {}, funName, '{"shareholderList":[{"shareholderSecuseq":0,"shareholderId":"0000000346","shareholderMarketId":"6"},{"shareholderSecuseq":0,"shareholderId":"A45944417402","shareholderMarketId":"7"},{"shareholderSecuseq":0,"shareholderId":"01X2220117","shareholderMarketId":"6"}],"fundId":"110002345509","randomKey":"Fundid:1494529838:110002345509","orgId":"xxxx"}');

	},
	formatPickerData: function () {
		let ret = {
			data: [],
			selectIndex: 0
		};
		for(let i = 0; i < dataObj.holderList.length; i++) {
			if(dataObj.holderId == dataObj.holderList[i].id) {
				ret.selectIndex = i;
			}
			ret.data.push(
				{
					text: (dataObj.holderList[i].market== '6' ? '特别转让A ': '特别转让B ') + dataObj.holderList[i].id,
					value: dataObj.holderList[i].id
				}
			)
		}
		return ret;

	},
	getData: function (url, reqParm, callback) {
		Com.ajax({
			'url': url,
			'data': reqParm,
			'type': 'post',
			'dataType': 'json',
			'success': function(data){
				Com.ajaxLoaded();
				callback && callback(data);
			},
			'isTradeLogin': true,//是否需要交易登录
			isNeedSign:true,
			'error': function(){
				UI.closeLoading();
				Com.showNativeAlert('', '网络不给力', ['确定'], '');
			}
		});
	},
	queryBuyCount: function () {
		//configData.isLoading = true;
		let url = Com.getOrigin() + '/gstrade/sharetransfer/queryBuyNum/1.0'
		let param = {
			market: dataObj.market,
			stkcode: dataObj.inputCode,
			bsflag: dataObj.type == 'buy' ? '0B' : '0S',
			secuid: dataObj.holderId,
			price: dataObj.price
		}
		exports.getData(url, param, function (data) {
			configData.isLoading = false;
			if(data.result && data.result[0].code == 0) {
				if(data.queryBuyNum_0 && data.queryBuyNum_0.length > 0) {
					dataObj.maxNuyNum = data.queryBuyNum_0[0].maxstkqty
				}

			}

		})
	},
	//如果是直接从列表点击返回时候会带有股东代码
	queryStockInfo: function (market, holderId) {
		let url = Com.getOrigin() + '/gstrade/sharetransfer/queryStockInfo/1.0?'
		let param = {
			market: market,
			stkcode: dataObj.inputCode
		}
		exports.getData(url, param, function (data) {
			if(data.result && data.result[0].code == 0) {
				if(data.queryStockInfo_0 && data.queryStockInfo_0.length > 0) {
					dataObj.stockInfo = data.queryStockInfo_0[0];
					dataObj.market = dataObj.stockInfo.market;
					if(dataObj.type == 'buy') {
						dataObj.price = dataObj.stockInfo.maxrisevalue;
					} else {
						dataObj.price = dataObj.stockInfo.maxdownvalue;
					}
                    if(holderId) {
	                    dataObj.holderMarket = dataObj.market;
                    } else {
	                    if(dataObj.holderMarket != dataObj.market) {
		                    exports.searchStockHolderFromMarket(dataObj.market);
	                    }

                    }
					exports.getHQinfo(dataObj.stockInfo.market);//获取行情
					dataObj.holderId && exports.queryBuyCount();//获取最大股数
					dataObj.buyUnit = Number(dataObj.stockInfo.buyunit) > 0 ? Number(dataObj.stockInfo.buyunit) : 1;
					if(Number(dataObj.stockInfo.pt_ordertype) != 1) {
						let txt = '当前股票不支持做市价挂牌买入委托';

						if(dataObj.type == 'sell') {
							txt = '当前股票不支持做市价挂牌卖出委托';
						}
						if(dataObj.stockInfo.pt_ordertype == 0 && dataObj.stockInfo.gztrdid && dataObj.stockInfo.gztrdid.toLocaleLowerCase() == 'j') {
							txt = '该证券没有涨跌幅，不支持市价委托'
						}
						Com.showNativeAlert('', txt, ['确定'], '');
					}
				}

			}

		})
	},
	//通过股票市场查找股东
	searchStockHolderFromMarket: function (market) {
		if(configData.holderList.length == 0 ) return;
		for(let i = 0; i < configData.holderList.length; i++) {
			if(configData.holderList[i].market == market) {
				dataObj.holderMarket = configData.holderList[i].market;
				dataObj.holderId = configData.holderList[i].id;
				return;
			}
		}

	},
	getHQinfo: function (market) {
		let url = Com.getOrigin() + '/gstrade/sharetransfer/queryStockHQ/1.0'
		let param = {
			market: market,
			stkcode: dataObj.inputCode
		}
		exports.getData(url, param, function (data) {
			if(data.result && data.result[0].code == 0) {
				if(data.queryStockHQ_0 && data.queryStockHQ_0.length > 0) {
					dataObj.hqInfo = data.queryStockHQ_0[0];
					dataObj.precision = dataObj.hqInfo.precision;
				}

			}

		})
	}
}

exports.init();