var dataObj={
	ofcodes:'',/*当前页面携带的ofcode列表用逗号分隔*/
	fxdatalist:[''],/*定投分析接口查询到的结果集*/
	defaultIndex:[
		{ofcode:'ix000001', code:'000001',secuabbr:"上证综指",id:"JY1"},
		{ofcode:'ix399005', code:'399005',secuabbr:"中小板指",id:"JY7542"},
		{ofcode:'ix399006', code:'399006',secuabbr:"创业板指",id:"JY11089"}
	],
	realList:[],/*ofcodesOfname concat defaultIndex*/
	ofcodesOfname:[],/*基金名称+基金代码数组*/
	coefArry:[],
	isred:false,
	dttimes:''/*平均定投时长*/

};
var appvue = new Vue({
	el:'#app',
	data:dataObj,
	created : function(){
		var self = this;
	},
	methods:{
		openpage:function(url){
			if(!url){
				return;
			}
			Com.newWebViewOpenPage('',{"pageUrl":Com.getOrigin()+url,"weburl":Com.getOrigin()+url});
		},
		dtxgxfxsm:function(){
			var splitStr =exports.splitStrHandle();
			Com.showScreenMask('相关性说明','衡量两只基金之间相关性的最常用的指标是相关系数，该系数的取值范围介于-100%至100%之间。'+splitStr+splitStr+'相关系数越接近100%，说明两只基金的变动方向越趋同；'+splitStr+'越趋近于0，说明两只基金的变动方向相关性不大；'+splitStr+'越趋近于-100%，则说明两只基金的变动方向越趋近于完全相反。'+splitStr+'在构建基金投资组合时应避免组合中的基金相关性高度趋近于1，因那是重复投资的表现，即做了无用功。'+splitStr+splitStr+'分析基金范围 ：当前有效的定投计划对应的基金。若超过10支，则取定投金额前十的基金（一支基金有多个定投计划的，取各定投金额之和）。');
		}
	},
	filters:{
		isredcolor:function(index1,index2){
			var index1code = dataObj.realList[index1].ofcode+''+dataObj.realList[index2].ofcode;
			var index2code = dataObj.realList[index2].ofcode+''+dataObj.realList[index1].ofcode;
			var coefnum=0;
			for(var i = 0;i<dataObj.coefArry.length;i++){
				var coefcode = dataObj.coefArry[i].coefcode;

				if(coefcode==index1code || coefcode==index2code){
					coefnum = (Number(dataObj.coefArry[i].coef).toFixed(2));
					return coefnum>0.8 ? '<span class="colorred">'+coefnum+'</span>' : '<span class="">'+coefnum+'</span>';
				}
			}
			return '--';
		}
	}
});
var exports = {
	init:function(){

		dataObj.ofcodes = Com.getQueryStringByName('ofcodes');

		exports.splitStr();

		//加载数据
		exports.getOfcodesData();

		//获取平均定投时长
		exports.getdttimes();

		//设置标题
		Com.setWebviewTitle('',{"title":'定投分析',"bgColor":""});

	},
	splitStr : function(){
		var clientType =Com.clientType();
		var splitStr='<br/>';
		if(clientType=='ios'){
			splitStr='\n';
		}
		dataObj.splitStr = splitStr;
	},

	/*获取定投相关性分析数据*/
	getOfcodesData : function(cb){
		var param = {};
		param['ofcodes'] = dataObj.ofcodes;
		Com.ajax({
			"url":Com.getOrigin()+'/gsfinancing/fundgroup/getixcfundcorr/1.0',
			"data":param,
			"type":"post",
			"dataType":"json",
			"success":function(d){
				if (d != null && d.result[0].code == '0') {


					if(d.data.length>0){
						cb && cb();

						//取名称
						exports.getOfcodesOfname(function(sd){
							dataObj.fxdatalist = d.data;
							for(var m = 0;m<d.data.length;m++){
								dataObj.coefArry.splice(m,1,{"coefcode":d.data[m].mfcodeA+''+d.data[m].mfcodeB,"coef":d.data[m].coef});
							}

							if(sd.data.length>0){
								/**
								 * 重要注释，勿删，定投系数不是所有入参的基金都有，所以如果需求是没有定投系数的基金不展示，那么需要打开以下注释
								 * 实现方案：遍历入参的基金列表和返回的定投系数列表，如果入参的基金在返回的定投系数中mfcodeA或者mfcodeB能找到
								 * 那么推入dataObj.ofcodesOfname
								 * */
								/*dataObj.ofcodesOfname=[];
								var len = dataObj.ofcodesOfname.length;
								for(var i = 0;i<sd.data.length;i++){
									len = dataObj.ofcodesOfname.length;
									for(var j = 0;j<dataObj.fxdatalist.length;j++){
										if((dataObj.fxdatalist[j].mfcodeA==sd.data[i].ofcode || dataObj.fxdatalist[j].mfcodeB==sd.data[i].ofcode)){
											dataObj.ofcodesOfname.splice(len, 1, {"ofcode":sd.data[i].ofcode,"ofname":sd.data[i].secuabbr})

										}
									}
								}
								dataObj.realList = dataObj.ofcodesOfname.concat(dataObj.defaultIndex);*/
								dataObj.realList = sd.data.concat(dataObj.defaultIndex);

							}
						});
					}
				}else if(d.result[0].code == '11' || d.result[0].code == '18' || d.result[0].code == '19'){
					return false;
				}else{
					Com.showNativeAlert('',d.result[0].code+':'+d.result[0].msg,['确定'],'');
				}
			},
			"isTradeLogin":false,
			"isNeedSign":true,
			"error":function(){
				Com.showNativeAlert('','网络不给力|getixcfundcorr',['确定'],'')
			}
		});
	},
	/*查多只基金名称*/
	getOfcodesOfname : function(cb){
		var param = {};
		param['ofcodes'] = dataObj.ofcodes.replace(/,/g,'|');
		Com.ajax({
			"url":Com.getOrigin()+'/gsfinancing/fundinfo/getfundinfolist/1.0',
			"data":param,
			"type":"post",
			"dataType":"json",
			"success":function(d){
				if (d != null && d.result[0].code == '0') {

					cb && cb(d);
				}else if(d.result[0].code == '11' || d.result[0].code == '18' || d.result[0].code == '19'){
					return false;
				}else{
					Com.showNativeAlert('',d.result[0].code+':'+d.result[0].msg,['确定'],'');
				}
			},
			"isTradeLogin":false,
			"isNeedSign":true,
			"error":function(){
				//Com.showNativeAlert('','网络不给力|getfundinfolist',['确定'],'')
			}
		});
	},

	/*查用户平均定投时间*/
	getdttimes : function(cb){
		var param = {};
		Com.ajax({
			"url":Com.getOrigin()+'/gsfinancing/ofschedule/calcSchedPlanTerm/1.0',
			"data":param,
			"type":"post",
			"dataType":"json",
			"success":function(d){
				if (d != null && d.result[0].code == '0') {
					if(d.data.length>0){
						dataObj.dttimes = d.data[0].investterm
					}

					cb && cb(d);
				}else if(d.result[0].code == '11' || d.result[0].code == '18' || d.result[0].code == '19'){
					return false;
				}else{
					Com.showNativeAlert('',d.result[0].code+':'+d.result[0].msg,['确定'],'');
				}
			},
			"isTradeLogin":true,
			"supportBioLogin":'2',
			"isNeedSign":true,
			"error":function(){
				Com.showNativeAlert('','网络不给力|getfundinfolist',['确定'],'')
			}
		});
	},
	//全屏说明内容段落分隔符
	splitStrHandle : function(){
		var clientType =Com.clientType();
		var splitStr='<br/>';
		if(clientType=='ios'){
			splitStr='\n';
		}
		return splitStr;
	}
};
exports.init();
